// Object which will handle the main canvas
var paint;

function PaintObject(maincvs) {
    this.started = false;

    // get handle of the main canvas, as a DOM object, not as a jQuery Object. Context is unfortunately not yet
    // available in jquery canvas wrapper object.
    var mainCanvas = $("#" + maincvs).get(0);

    // Check if everything is ok
    if (!mainCanvas) {alert("canvas undefined, does not seem to be supported by your browser");}
    if (!mainCanvas.getContext) {alert('Error: canvas.getContext() undefined !');}

    // Get the context for drawing in the canvas
    var mainContext = mainCanvas.getContext('2d');
    if (!mainContext) {alert("could not get the context for the main canvas");}

    this.getMainCanvas = function () {
        return mainCanvas;
    }
    this.getMainContext = function () {
        return mainContext;
    }

    // Create the drawing tool
    var drawingTool = new pencilDrawingTool();

    // Bind events on the canvas
    $("#canvasMain").mousedown(drawingTool.mouseDownListener);
    $("#canvasMain").mousemove(drawingTool.mouseMoveListener);
    $("#canvasMain").mouseup(drawingTool.mouseUpListener);

    // Canvas doesnt scale well with '%' dimension so we use a little trick.
    // We give them the size of one of their parent node which can be scalable.
    mainCanvas.height = $("#content")[0].clientHeight;
    mainCanvas.width = $("#content")[0].clientWidth;
}

