// Use the express module for nodeJS
// Express is a framework for implementing a more
// complete web server with nodeJS
var express = require('express');

var app = express.createServer();

// Indicate where static files are located
app.configure(function () {
    app.use(express.static(__dirname + '/client/'));
});
app.get('/', function (req, res) {
    //res.render('client/paint.html');
    res.redirect("/paint.html");
});
app.listen(8080);

// Creation of a web socket server using nowJS
var nowjs = require("now");
var everyone = nowjs.initialize(app);


nowjs.on("connect", function () {
    console.log("Joined: " + this.user.clientId);
});

nowjs.on("disconnect", function () {
    console.log("Left: " + this.user.clientId);
    nowjs.getClient(this.user.clientId,function(){
        console.log(this.now.name);
        //need to remove user for array
        //userlist.po (this.now.name);
    });
    updateList();
});

// Function called by a chat client, passes the message to each client
// connected by calling its processIncomingChatMessage shared function
everyone.now.distributeMessage = function (message) {
    // send the message to everyone
    everyone.now.processIncomingChatMessage(this.now.name, message);
};

everyone.now.distributePaintCommand = function (paintCommand) {
    // send the paint command to everyone except sender
    everyone.exclude(this.user.clientId).now.processPaintCommand(paintCommand);
};

everyone.now.setName = function(){
    userlist.push(this.now.name);
    console.log(userlist);
    //this.now.updateUserList(userlist);
    everyone.now.updateUserList(userlist);
};

var userlist = [];

updateList = function(){
    userlist = [];
    everyone.getUsers(function (users) {
        for (var i = 0; i < users.length; i++){
            //console.log(users[i] + " : ");
            nowjs.getClient(users[i],function(){
                console.log(this.now.name);
                userlist.push(this.now.name);
            });
        }
    });
};

everyone.now.getUserList = function() {
    this.now.updateUserList(userlist);
};